uniform sampler2DRect image;


varying vec2 s1Coord;
varying vec2 s2Coord;
varying vec2 s3Coord;
varying vec2 s4Coord;
varying vec2 s5Coord;
varying vec2 s6Coord;
varying vec2 s7Coord;
varying vec2 s8Coord;

uniform sampler2DRect tex0;

uniform float coef;

const vec4 lumcoeff = vec4(0.299,0.587,0.114,0.);

void main (void)
{
			float h00 = dot(lumcoeff,texture2DRect( tex0, s1Coord ));
			float h10 = dot(lumcoeff,texture2DRect( tex0, s2Coord ));
			float h20 = dot(lumcoeff,texture2DRect( tex0, s3Coord ));

			float h01 = dot(lumcoeff,texture2DRect( tex0, s4Coord ));
			float h21 = dot(lumcoeff,texture2DRect( tex0, s5Coord ));

			float h02 = dot(lumcoeff,texture2DRect( tex0, s6Coord ));
			float h12 = dot(lumcoeff,texture2DRect( tex0, s7Coord ));
			float h22 = dot(lumcoeff,texture2DRect( tex0, s8Coord ));
			
			float Gx = h00 - h20 + 2.0 * h01 - 2.0 * h21 + h02 - h22;
			float Gy = h00 + 2.0 * h10 + h20 - h02 - 2.0 * h12 - h22;
			
			// Make sure the returned normal is of unit length
			vec4 N = vec4( normalize( vec3( 2.0 * Gx, 2.0 * Gy, coef)) , 1.0);
			
			gl_FragColor = N * 0.5 + 0.5;

}